import pytest
import os
from src.fdc.fdc import FDC
import json

get_food_test_data = [("2262077",
                       '{"fdcId":2262077,"description":"peanut butter, creamy","publicationDate":"4/28/2022","dataType":"Sample","foodClass":"Composite","foodComponents":[],"foodAttributes":[],"foodNutrients":[{"type":"labAnalysisSubSampleResult","nutrient":{"id":1227,"number":"518","name":"Serine","rank":18000,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794851,"amount":1.39000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1095,"number":"309","name":"Zinc, Zn","rank":5900,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794862,"amount":2.74000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1265,"number":"613","name":"SFA 16:0","rank":10700,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794810,"amount":4.80500000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1226,"number":"517","name":"Proline","rank":17900,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794849,"amount":1.26000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1211,"number":"502","name":"Threonine","rank":16400,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794853,"amount":0.78000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1091,"number":"305","name":"Phosphorus, P","rank":5600,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794847,"amount":383.00000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1002,"number":"202","name":"Nitrogen","rank":500,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794845,"amount":4.39000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1267,"number":"615","name":"SFA 20:0","rank":11100,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794814,"amount":0.71900000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1210,"number":"501","name":"Tryptophan","rank":16300,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794858,"amount":0.23000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1090,"number":"304","name":"Magnesium, Mg","rank":5500,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794841,"amount":189.00000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1258,"number":"606","name":"Fatty acids, total saturated","rank":9700,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794857,"amount":9.46000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1051,"number":"255","name":"Water","rank":100,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794844,"amount":1.12000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1273,"number":"624","name":"SFA 22:0","rank":11200,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794816,"amount":1.54600000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":2012,"number":"829","name":"MUFA 20:1 c","rank":12401,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794815,"amount":0.66400000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1176,"number":"416","name":"Biotin","rank":6850,"unitName":"µg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794822,"amount":93.60000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1177,"number":"417","name":"Folate, total","rank":6900,"unitName":"µg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794829,"amount":113.00000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1079,"number":"291","name":"Fiber, total dietary","rank":1200,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794856,"amount":6.01000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1228,"number":"521","name":"Hydroxyproline","rank":18100,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794836,"amount":0.15000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1225,"number":"516","name":"Glycine","rank":17800,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794833,"amount":1.71000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1007,"number":"207","name":"Ash","rank":1000,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794820,"amount":2.91000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1341,"number":"711","name":"Genistein","rank":19200,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794830,"loq":0.01300000,"amount":0E-8,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":2050,"number":"718","name":"Genistin","rank":19320,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794831,"amount":1.89000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":2051,"number":"719","name":"Glycitin","rank":19330,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794834,"amount":0.51000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1217,"number":"508","name":"Phenylalanine","rank":17000,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794846,"amount":1.47000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1223,"number":"514","name":"Aspartic acid","rank":17600,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794821,"amount":3.33000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1093,"number":"307","name":"Sodium, Na","rank":5800,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794852,"amount":284.00000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":2049,"number":"717","name":"Daidzin","rank":19310,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794827,"amount":0.67300000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1340,"number":"710","name":"Daidzein","rank":19100,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794826,"amount":9.27000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1232,"number":"526","name":"Cysteine","rank":18150,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794825,"amount":0.54000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1220,"number":"511","name":"Arginine","rank":17300,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794819,"amount":3.22000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1213,"number":"504","name":"Leucine","rank":16600,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794839,"amount":1.84000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1089,"number":"303","name":"Iron, Fe","rank":5400,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794837,"amount":1.79000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1224,"number":"515","name":"Glutamic acid","rank":17700,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794832,"amount":5.70000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1103,"number":"317","name":"Selenium, Se","rank":6200,"unitName":"µg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794850,"amount":8.67000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1221,"number":"512","name":"Histidine","rank":17400,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794835,"amount":0.66000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1004,"number":"204","name":"Total lipid (fat)","rank":800,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794828,"amount":52.85000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1092,"number":"306","name":"Potassium, K","rank":5700,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794848,"amount":677.00000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1293,"number":"646","name":"Fatty acids, total polyunsaturated","rank":12900,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794855,"amount":12.67000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1212,"number":"503","name":"Isoleucine","rank":16500,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794838,"amount":0.88000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1266,"number":"614","name":"SFA 18:0","rank":10900,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794811,"amount":1.50400000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1215,"number":"506","name":"Methionine","rank":16800,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794843,"amount":0.28000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1218,"number":"509","name":"Tyrosine","rank":17100,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794859,"amount":1.02000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1301,"number":"654","name":"SFA 24:0","rank":11300,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794817,"amount":0.80900000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1214,"number":"505","name":"Lysine","rank":16700,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794840,"amount":0.97000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1087,"number":"301","name":"Calcium, Ca","rank":5300,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794823,"amount":47.50000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1219,"number":"510","name":"Valine","rank":17200,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794860,"amount":1.05000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1101,"number":"315","name":"Manganese, Mn","rank":6100,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794842,"amount":1.82000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1315,"number":"674","name":"MUFA 18:1 c","rank":12200,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794812,"amount":26.85500000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1222,"number":"513","name":"Alanine","rank":17500,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794818,"amount":1.10000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1316,"number":"675","name":"PUFA 18:2 n-6 c,c","rank":13200,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794813,"amount":12.62100000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1098,"number":"312","name":"Copper, Cu","rank":6000,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794824,"amount":0.50500000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1292,"number":"645","name":"Fatty acids, total monounsaturated","rank":11400,"unitName":"g"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794854,"amount":27.63000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1165,"number":"404","name":"Thiamin","rank":6400,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27794861,"amount":0.13700000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1109,"number":"323","name":"Vitamin E (alpha-tocopherol)","rank":7905,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27795667,"amount":5.45000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1167,"number":"406","name":"Niacin","rank":6600,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27795724,"amount":15.20000000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1175,"number":"415","name":"Vitamin B-6","rank":6800,"unitName":"mg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":27795692,"amount":0.41500000,"dataPoints":1},{"type":"labAnalysisSubSampleResult","nutrient":{"id":1185,"number":"430","name":"Vitamin K (phylloquinone)","rank":8800,"unitName":"µg"},"foodNutrientDerivation":{"id":1,"code":"A","description":"Analytical"},"id":28913061,"loq":0.10000000,"amount":0E-8,"dataPoints":1}],"foodPortions":[],"foodCategory":{"id":16,"code":"1600","description":"Legumes and Legume Products"}}'),
                      ("2262078",
                       '{"fdcId":2262078,"description":"peanut butter, creamy","publicationDate":"4/28/2022","dataType":"Market Acquisition","foodClass":"SampleUnit","foodComponents":[],"labelWeight":"16 oz ","location":"","acquisitionDate":"6/27/2021","brandDescription":"Smucker\'s Natural","sampleLotNumber":"11340040109:02","storeCity":"Ellicott City","storeName":"Harris Teeter","storeState":"MD","upcCode":"51500 01700","foodCategory":{"id":16,"code":"1600","description":"Legumes and Legume Products"}}')
                      ]

get_foods_test_data = [(["2262077", "2262078"],
                        '[{"fdcId":2262077, "description":"peanut butter, creamy", "publicationDate":"4/28/2022", "dataType":"Sample", "foodClass":"Composite", "foodComponents":[], "foodAttributes":[], "foodNutrients":[{"type":"labAnalysisSubSampleResult", "nutrient":{"id":1227, "number":"518", "name":"Serine", "rank":18000, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794851, "amount":1.39000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1095, "number":"309", "name":"Zinc, Zn", "rank":5900, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794862, "amount":2.74000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1265, "number":"613", "name":"SFA 16:0", "rank":10700, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794810, "amount":4.80500000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1226, "number":"517", "name":"Proline", "rank":17900, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794849, "amount":1.26000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1211, "number":"502", "name":"Threonine", "rank":16400, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794853, "amount":0.78000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1091, "number":"305", "name":"Phosphorus, P", "rank":5600, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794847, "amount":383.00000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1002, "number":"202", "name":"Nitrogen", "rank":500, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794845, "amount":4.39000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1267, "number":"615", "name":"SFA 20:0", "rank":11100, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794814, "amount":0.71900000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1210, "number":"501", "name":"Tryptophan", "rank":16300, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794858, "amount":0.23000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1090, "number":"304", "name":"Magnesium, Mg", "rank":5500, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794841, "amount":189.00000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1258, "number":"606", "name":"Fatty acids, total saturated", "rank":9700, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794857, "amount":9.46000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1051, "number":"255", "name":"Water", "rank":100, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794844, "amount":1.12000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1273, "number":"624", "name":"SFA 22:0", "rank":11200, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794816, "amount":1.54600000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":2012, "number":"829", "name":"MUFA 20:1 c", "rank":12401, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794815, "amount":0.66400000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1176, "number":"416", "name":"Biotin", "rank":6850, "unitName":"µg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794822, "amount":93.60000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1177, "number":"417", "name":"Folate, total", "rank":6900, "unitName":"µg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794829, "amount":113.00000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1079, "number":"291", "name":"Fiber, total dietary", "rank":1200, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794856, "amount":6.01000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1228, "number":"521", "name":"Hydroxyproline", "rank":18100, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794836, "amount":0.15000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1225, "number":"516", "name":"Glycine", "rank":17800, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794833, "amount":1.71000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1007, "number":"207", "name":"Ash", "rank":1000, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794820, "amount":2.91000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1341, "number":"711", "name":"Genistein", "rank":19200, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794830, "loq":0.01300000, "amount":0E-8, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":2050, "number":"718", "name":"Genistin", "rank":19320, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794831, "amount":1.89000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":2051, "number":"719", "name":"Glycitin", "rank":19330, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794834, "amount":0.51000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1217, "number":"508", "name":"Phenylalanine", "rank":17000, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794846, "amount":1.47000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1223, "number":"514", "name":"Aspartic acid", "rank":17600, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794821, "amount":3.33000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1093, "number":"307", "name":"Sodium, Na", "rank":5800, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794852, "amount":284.00000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":2049, "number":"717", "name":"Daidzin", "rank":19310, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794827, "amount":0.67300000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1340, "number":"710", "name":"Daidzein", "rank":19100, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794826, "amount":9.27000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1232, "number":"526", "name":"Cysteine", "rank":18150, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794825, "amount":0.54000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1220, "number":"511", "name":"Arginine", "rank":17300, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794819, "amount":3.22000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1213, "number":"504", "name":"Leucine", "rank":16600, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794839, "amount":1.84000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1089, "number":"303", "name":"Iron, Fe", "rank":5400, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794837, "amount":1.79000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1224, "number":"515", "name":"Glutamic acid", "rank":17700, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794832, "amount":5.70000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1103, "number":"317", "name":"Selenium, Se", "rank":6200, "unitName":"µg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794850, "amount":8.67000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1221, "number":"512", "name":"Histidine", "rank":17400, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794835, "amount":0.66000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1004, "number":"204", "name":"Total lipid (fat)", "rank":800, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794828, "amount":52.85000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1092, "number":"306", "name":"Potassium, K", "rank":5700, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794848, "amount":677.00000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1293, "number":"646", "name":"Fatty acids, total polyunsaturated", "rank":12900, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794855, "amount":12.67000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1212, "number":"503", "name":"Isoleucine", "rank":16500, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794838, "amount":0.88000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1266, "number":"614", "name":"SFA 18:0", "rank":10900, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794811, "amount":1.50400000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1215, "number":"506", "name":"Methionine", "rank":16800, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794843, "amount":0.28000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1218, "number":"509", "name":"Tyrosine", "rank":17100, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794859, "amount":1.02000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1301, "number":"654", "name":"SFA 24:0", "rank":11300, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794817, "amount":0.80900000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1214, "number":"505", "name":"Lysine", "rank":16700, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794840, "amount":0.97000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1087, "number":"301", "name":"Calcium, Ca", "rank":5300, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794823, "amount":47.50000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1219, "number":"510", "name":"Valine", "rank":17200, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794860, "amount":1.05000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1101, "number":"315", "name":"Manganese, Mn", "rank":6100, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794842, "amount":1.82000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1315, "number":"674", "name":"MUFA 18:1 c", "rank":12200, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794812, "amount":26.85500000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1222, "number":"513", "name":"Alanine", "rank":17500, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794818, "amount":1.10000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1316, "number":"675", "name":"PUFA 18:2 n-6 c,c", "rank":13200, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794813, "amount":12.62100000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1098, "number":"312", "name":"Copper, Cu", "rank":6000, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794824, "amount":0.50500000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1292, "number":"645", "name":"Fatty acids, total monounsaturated", "rank":11400, "unitName":"g"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794854, "amount":27.63000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1165, "number":"404", "name":"Thiamin", "rank":6400, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27794861, "amount":0.13700000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1109, "number":"323", "name":"Vitamin E (alpha-tocopherol)", "rank":7905, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27795667, "amount":5.45000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1167, "number":"406", "name":"Niacin", "rank":6600, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27795724, "amount":15.20000000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1175, "number":"415", "name":"Vitamin B-6", "rank":6800, "unitName":"mg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":27795692, "amount":0.41500000, "dataPoints":1}, {"type":"labAnalysisSubSampleResult", "nutrient":{"id":1185, "number":"430", "name":"Vitamin K (phylloquinone)", "rank":8800, "unitName":"µg"}, "foodNutrientDerivation":{"id":1, "code":"A", "description":"Analytical"}, "id":28913061, "loq":0.10000000, "amount":0E-8, "dataPoints":1}], "foodPortions":[], "foodCategory":{"id":16, "code":"1600", "description":"Legumes and Legume Products"}}, {"fdcId":2262078,"description":"peanut butter, creamy","publicationDate":"4/28/2022","dataType":"Market Acquisition","foodClass":"SampleUnit","foodComponents":[],"labelWeight":"16 oz ","location":"","acquisitionDate":"6/27/2021","brandDescription":"Smucker\'s Natural","sampleLotNumber":"11340040109:02","storeCity":"Ellicott City","storeName":"Harris Teeter","storeState":"MD","upcCode":"51500 01700","foodCategory":{"id":16,"code":"1600","description":"Legumes and Legume Products"}}]'
                        )]

with open("list_expected.json", "r") as file:
    list_expected = json.load(file)

get_foods_list_data = [("Foundation", 1, 1, "publishedDate", "asc", list_expected[0])]


class TestRawApiCalls:
    api_key = os.environ["api_key"]
    client = FDC(api_key)

    @pytest.mark.parametrize("fdc_id,food_expected", get_food_test_data)
    def test_get_food_raw(self, fdc_id, food_expected):
        food_queried = json.loads(self.client.get_food_raw(fdc_id))
        assert food_queried == json.loads(food_expected)

    @pytest.mark.parametrize("fdc_ids,foods_expected", get_foods_test_data)
    def test_get_foods_raw(self, fdc_ids, foods_expected):
        foods_queried = json.loads(self.client.get_foods_raw(fdc_ids))
        assert foods_queried == json.loads(foods_expected)

    @pytest.mark.parametrize("data_type,page_size,page_number,sort_by,sort_order,list_expected", get_foods_list_data)
    def test_get_foods_list_raw(self, data_type, page_size, page_number, sort_by, sort_order, list_expected):
        list_queried = json.loads(self.client.get_foods_list_raw(data_type, page_size, page_number, sort_by,
                                                                  sort_order))
        assert list_queried == json.loads(list_expected)
